'\"
.\"
.\" .HS name section [date [version]]
.\"	Replacement for .TH in other man pages.  See below for valid
.\"	section names.
.\"
.\" .AP type name in/out [indent]
.\"	Start paragraph describing an argument to a library procedure.
.\"	type is type of argument (int, etc.), in/out is either "in", "out",
.\"	or "in/out" to describe whether procedure reads or modifies arg,
.\"	and indent is equivalent to second arg of .IP (shouldn't ever be
.\"	needed;  use .AS below instead)
.\"
.\" .AS [type [name]]
.\"	Give maximum sizes of arguments for setting tab stops.  Type and
.\"	name are examples of largest possible arguments that will be passed
.\"	to .AP later.  If args are omitted, default tab stops are used.
.\"
.\" .BS
.\"	Start box enclosure.  From here until next .BE, everything will be
.\"	enclosed in one large box.
.\"
.\" .BE
.\"	End of box enclosure.
.\"
.\" .VS
.\"	Begin vertical sidebar, for use in marking newly-changed parts
.\"	of man pages.
.\"
.\" .VE
.\"	End of vertical sidebar.
.\"
.\" .DS
.\"	Begin an indented unfilled display.
.\"
.\" .DE
.\"	End of indented unfilled display.
.\"
'\"	# Heading for TIX man pages
.de HS
.if '\\$2'tix'        .TH \\$1 n \\$3 \\TIX
.if t .wh -1.3i ^B
.nr ^l \\n(.l
.ad b
..
'\"	# Start an argument description
.de AP
.ie !"\\$4"" .TP \\$4
.el \{\
.   ie !"\\$2"" .TP \\n()Cu
.   el          .TP 15
.\}
.ie !"\\$3"" \{\
.ta \\n()Au \\n()Bu
\&\\$1	\\fI\\$2\\fP	(\\$3)
.\".b
.\}
.el \{\
.br
.ie !"\\$2"" \{\
\&\\$1	\\fI\\$2\\fP
.\}
.el \{\
\&\\fI\\$1\\fP
.\}
.\}
..
'\"	# define tabbing values for .AP
.de AS
.nr )A 10n
.if !"\\$1"" .nr )A \\w'\\$1'u+3n
.nr )B \\n()Au+15n
.\"
.if !"\\$2"" .nr )B \\w'\\$2'u+\\n()Au+3n
.nr )C \\n()Bu+\\w'(in/out)'u+2n
..
'\"	# BS - start boxed text
'\"	# ^y = starting y location
'\"	# ^b = 1
.de BS
.br
.mk ^y
.nr ^b 1u
.if n .nf
.if n .ti 0
.if n \l'\\n(.lu\(ul'
.if n .fi
..
'\"	# BE - end boxed text (draw box now)
.de BE
.nf
.ti 0
.mk ^t
.ie n \l'\\n(^lu\(ul'
.el \{\
.\"	Draw four-sided box normally, but don't draw top of
.\"	box if the box started on an earlier page.
.ie !\\n(^b-1 \{\
\h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.el \}\
\h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.\}
.fi
.br
.nr ^b 0
..
'\"	# VS - start vertical sidebar
'\"	# ^Y = starting y location
'\"	# ^v = 1 (for troff;  for nroff this doesn't matter)
.de VS
.mk ^Y
.ie n 'mc \s12\(br\s0
.el .nr ^v 1u
..
'\"	# VE - end of vertical sidebar
.de VE
.ie n 'mc
.el \{\
.ev 2
.nf
.ti 0
.mk ^t
\h'|\\n(^lu+3n'\L'|\\n(^Yu-1v\(bv'\v'\\n(^tu+1v-\\n(^Yu'\h'-|\\n(^lu+3n'
.sp -1
.fi
.ev
.\}
.nr ^v 0
..
'\"	# Special macro to handle page bottom:  finish off current
'\"	# box/sidebar if in box/sidebar mode, then invoked standard
'\"	# page bottom macro.
.de ^B
.ev 2
'ti 0
'nf
.mk ^t
.if \\n(^b \{\
.\"	Draw three-sided box if this is the box's first page,
.\"	draw two sides but no top otherwise.
.ie !\\n(^b-1 \h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.el \h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.\}
.if \\n(^v \{\
.nr ^x \\n(^tu+1v-\\n(^Yu
\kx\h'-\\nxu'\h'|\\n(^lu+3n'\ky\L'-\\n(^xu'\v'\\n(^xu'\h'|0u'\c
.\}
.bp
'fi
.ev
.if \\n(^b \{\
.mk ^y
.nr ^b 2
.\}
.if \\n(^v \{\
.mk ^Y
.\}
..
'\"	# DS - begin display
.de DS
.RS
.nf
.sp
..
'\"	# DE - end display
.de DE
.fi
.RE
.sp .5
..
'
'
'----------------------------------------------------------------------
.HS tixControl tix 3.6
.BS
'
'
'----------------------------------------------------------------------
.SH NAME
tixControl - Create and manipulate TIX \fBControl\fR widgets
'
'
'
'----------------------------------------------------------------------
.SH SYNOPSIS
\fBtixControl\fI \fIpathName ?\fIoptions\fR?
'
'
'
'----------------------------------------------------------------------
.SH "STANDARD OPTIONS"
.LP
.nf
.ta 4c 8c 12c
.VS
\fB
'
anchor	background	cursor
relief	borderWidth	geometry
'
\fR
.fi
.LP
See the ``options'' manual entry for details on the standard options.
'
'
'----------------------------------------------------------------------
.SH "WIDGET-SPECIFIC OPTIONS"
'
'----------BEGIN
.LP
.nf
Name:		\fBautorepeat\fR
Class:		\fBAutorepeat\fR
Command-Line Switch:	\fB\-autorepeat\fR
.fi
.IP
Specifies whether the \fBControl\fR should have autorepeat behavior.
If set to be "true", the value of the \fBControl\fR will be
automatically incremented or decremented when the user holds down the
mouse button over the arrow buttons. Only values "true" and
"false" will be recognized.
'----------END

'----------BEGIN
.LP
.nf
Name:		\fBbuttonBg\fR
Class:		\fBBackground\fR
Command-Line Switch:	\fB\-buttonbg\fR
.fi
.IP
Specifies the background of the two arrow button subwidgets inside the 
\fBControl\fR widget.
'----------END
'
'----------BEGIN
.LP
.nf
Name:		\fBbuttonFg\fR
Class:		\fBForeground\fR
Command-Line Switch:	\fB\-buttonfg\fR
.fi
.IP
Specifies the foreground used by the two arrow button subwdgets.
'----------END
'
'----------BEGIN
.LP
.nf
Name:		\fBcommand\fR
Class:		\fBCommand\fR
Command-Line Switch:	\fB\-command\fR
.fi
.IP
Specifies the command to be called when the \fBControl\fR is invoked:
(1) when the user adjust the value using the arrowbuttons, or (2) when
the user press <Return> inside the entry widget.

The command will be called with one arguments -- the value of the
\fBControl\fR widget.
'----------END
'
'----------BEGIN
.LP
.nf
Name:		\fBdisabledforeground\fR
Class:		\fBDisabledForeground\fR
Command-Line Switch:	\fB\-disabledforeground\fR
.fi
.IP
Specifies the foreground color to be used when the \fBControl\fR
widget is disabled.
'----------END
'
'----------BEGIN
.LP
.nf
Name:		\fBentryBg\fR
Class:		\fBBackground\fR
Command-Line Switch:	\fB\-entrybg\fR
.fi
.IP
Specifies the background of the entry subwidget.
'----------END
'
'----------BEGIN
.LP
.nf
Name:		\fBentryWidth\fR
Class:		\fBEntryWidth\fR
Command-Line Switch:	\fB\-entrywidth\fR
.fi
.IP
Specifies the width of the entry subwidget.
'----------END
'
'----------BEGIN
.LP
.nf
Name:		\fBfont\fR
Class:		\fBFont\fR
Command-Line Switch:	\fB\-font\fR
.fi
.IP
Specifies the font used the entry subwidget inside the \fBControl\fR widget.
'----------END
'
'----------BEGIN
.LP
.nf
Name:		\fBforeground\fR
Class:		\fBForeground\fR
Command-Line Switch:	\fB\-foreground\fR
.fi
.IP
Specifies the foreground color of the entry subwdget.
'----------END
'
'----------BEGIN
.LP
.nf
Name:		\fBinitwait\fR
Class:		\fBInitwait\fR
Command-Line Switch:	\fB\-initwait\fR
.fi
.IP
Specifies how long the \fBControl\fR should wait initially before it
starts to automatically increment or decrement its value in the autorepeat
mode. In milliseconds.
'----------END
'
'----------BEGIN
.LP
.nf
Name:		\fBllimit\fR
Class:		\fBLlimit\fR
Command-Line Switch:	\fB\-llimit\fR
.fi
.IP
Specifies the lower limit of the value of the \fBControl\fR.When set
to empty string, the \fBControl\fR has no lower limit.
'----------END
'
'----------BEGIN
.LP
.nf
Name:		\fBrepeatReat\fR
Class:		\fBRepeatRate\fR
Command-Line Switch:	\fB-repeatrate\fR
.fi
.IP
Specifies how often the value of the \fBControl\fR widget should be
incremented or decremented when it is in the autorepeat mode. In
milliseconds.
'----------END
'
'
'----------BEGIN
.LP
.nf
Name:		\fBstate\fR
Class:		\fBState\fR
Command-Line Switch:	\fB\-state\fR
.fi
.IP
Specifies the whether the \fBControl\fR widget is normal or disabled.
Only the values "normal" and "disabled" are recognized.
'----------END
'
'----------BEGIN
.LP
.nf
Name:		\fBstep\fR
Class:		\fBStep\fR
Command-Line Switch:	\fB\-step\fR
.fi
.IP
Specifies by how much the value of the \fBControl\fR should be
incremented or decrmented when the user press the arrow buttons.
'----------END
'
'----------BEGIN
.LP
.nf
Name:		\fBulimit\fR
Class:		\fBUlimit\fR
Command-Line Switch:	\fB\-ulimit\fR
.fi
.IP
Specifies the upper limit of the value of the \fBControl\fR. When set
to empty string, the \fBControl\fR has no upper limit.
'----------END
'
'
'----------BEGIN
.LP
.nf
Name:		\fBvalue\fR
Class:		\fBValue\fR
Command-Line Switch:	\fB\-value\fR
.fi
.IP
Specifies the value of the \fBControl\fR.
'----------END
'
'----------BEGIN
.LP
.nf
Name:		\fBvariable\fR
Class:		\fBVariable\fR
Command-Line Switch:	\fB\-variable\fR
.fi
.IP
Specifies the global variable in which the value of the
\fBControl\fR should be stored. The value of the \fBControl\fR will be
automatically updated when this variable is changed.
'----------END
'
.VE
.BE
'
'
'----------------------------------------------------------------------
.SH DESCRIPTION
'
.PP
'
The \fBtixControl\fR command creates a new window (given by the
\fIpathName\fR argument) and makes it into a \fBControl\fR widget.
Additional options, described above, may be specified on the command
line or in the option database to configure aspects of the
\fBControl\fR such as its cursor and relief.

The \fBControl\fR widget is generally used to control a value. The
user can adjust the value by pressing the two arrow buttons or by
entering the value directly into the entry. The new value will be
checked against the user-defined upper and lower limits.

'
'----------------------------------------------------------------------
.SH WIDGET COMMANDS
.PP
'
The \fBControl\fR command creates a new Tcl command whose
name is the same as the path name of the \fBControl\fR's window.  This
command may be used to invoke various
operations on the widget. It has the following general form:
'
.DS C
'
\fIpathName option \fR?\fIarg arg ...\fR?

.DE
'
\fIPathName\fR is the name of the command, which is the same as
the frame widget's path name.  \fIOption\fR and the \fIarg\fRs
determine the exact behavior of the command.  The following
commands are possible for \fBControl\fR widgets:
'
.TP
'
\fIpathName \fBconfigure\fR ?\fIoption\fR? \fI?value option value ...\fR?
Query or modify the configuration options of the widget.
If no \fIoption\fR is specified, returns a list describing all of
the available options for \fIpathName\fR (see \fBTk_ConfigureInfo\fR for
information on the format of this list).  If \fIoption\fR is specified
with no \fIvalue\fR, then the command returns a list describing the
one named option (this list will be identical to the corresponding
sublist of the value returned if no \fIoption\fR is specified).  If
one or more \fIoption\-value\fR pairs are specified, then the command
modifies the given widget option(s) to have the given value(s);  in
this case the command returns an empty string.
\fIOption\fR may have any of the values accepted by the \fBframe\fR
command.
'
.TP
\fIpathName \fBdecr\fR
Decrement the value of the \fBControl\fR widget by the step specified
by the \fI-step\fR option.
'
.TP
\fIpathName \fBget\fR
return the value of the \fBControl\fR widget.
'
.TP
\fIpathName \fBincr\fR
Increment the value of the \fBControl\fR widget by the step specified
by the \fI-step\fR option.
'
'
.TP
\fIpathName \fBinvoke\fR
Cause the command specified by the \fI-command\fR option to be invoked.
'
'----------------------------------------------------------------------
.SH BINDINGS
.PP
\fBControl\fR widgets have no default bindings.
'
'
'
'----------------------------------------------------------------------
.SH AUTHOR
.PP
Ioi Kim Lam - ioi@graphics.cis.upenn.edu
'
'----------------------------------------------------------------------
.SH KEYWORDS
TIX, Container Widgets
