'\"
.\"
.\" .HS name section [date [version]]
.\"	Replacement for .TH in other man pages.  See below for valid
.\"	section names.
.\"
.\" .AP type name in/out [indent]
.\"	Start paragraph describing an argument to a library procedure.
.\"	type is type of argument (int, etc.), in/out is either "in", "out",
.\"	or "in/out" to describe whether procedure reads or modifies arg,
.\"	and indent is equivalent to second arg of .IP (shouldn't ever be
.\"	needed;  use .AS below instead)
.\"
.\" .AS [type [name]]
.\"	Give maximum sizes of arguments for setting tab stops.  Type and
.\"	name are examples of largest possible arguments that will be passed
.\"	to .AP later.  If args are omitted, default tab stops are used.
.\"
.\" .BS
.\"	Start box enclosure.  From here until next .BE, everything will be
.\"	enclosed in one large box.
.\"
.\" .BE
.\"	End of box enclosure.
.\"
.\" .VS
.\"	Begin vertical sidebar, for use in marking newly-changed parts
.\"	of man pages.
.\"
.\" .VE
.\"	End of vertical sidebar.
.\"
.\" .DS
.\"	Begin an indented unfilled display.
.\"
.\" .DE
.\"	End of indented unfilled display.
.\"
'\"	# Heading for TIX man pages
.de HS
.if '\\$2'tix'        .TH \\$1 n \\$3 \\TIX
.if t .wh -1.3i ^B
.nr ^l \\n(.l
.ad b
..
'\"	# Start an argument description
.de AP
.ie !"\\$4"" .TP \\$4
.el \{\
.   ie !"\\$2"" .TP \\n()Cu
.   el          .TP 15
.\}
.ie !"\\$3"" \{\
.ta \\n()Au \\n()Bu
\&\\$1	\\fI\\$2\\fP	(\\$3)
.\".b
.\}
.el \{\
.br
.ie !"\\$2"" \{\
\&\\$1	\\fI\\$2\\fP
.\}
.el \{\
\&\\fI\\$1\\fP
.\}
.\}
..
'\"	# define tabbing values for .AP
.de AS
.nr )A 10n
.if !"\\$1"" .nr )A \\w'\\$1'u+3n
.nr )B \\n()Au+15n
.\"
.if !"\\$2"" .nr )B \\w'\\$2'u+\\n()Au+3n
.nr )C \\n()Bu+\\w'(in/out)'u+2n
..
'\"	# BS - start boxed text
'\"	# ^y = starting y location
'\"	# ^b = 1
.de BS
.br
.mk ^y
.nr ^b 1u
.if n .nf
.if n .ti 0
.if n \l'\\n(.lu\(ul'
.if n .fi
..
'\"	# BE - end boxed text (draw box now)
.de BE
.nf
.ti 0
.mk ^t
.ie n \l'\\n(^lu\(ul'
.el \{\
.\"	Draw four-sided box normally, but don't draw top of
.\"	box if the box started on an earlier page.
.ie !\\n(^b-1 \{\
\h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.el \}\
\h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.\}
.fi
.br
.nr ^b 0
..
'\"	# VS - start vertical sidebar
'\"	# ^Y = starting y location
'\"	# ^v = 1 (for troff;  for nroff this doesn't matter)
.de VS
.mk ^Y
.ie n 'mc \s12\(br\s0
.el .nr ^v 1u
..
'\"	# VE - end of vertical sidebar
.de VE
.ie n 'mc
.el \{\
.ev 2
.nf
.ti 0
.mk ^t
\h'|\\n(^lu+3n'\L'|\\n(^Yu-1v\(bv'\v'\\n(^tu+1v-\\n(^Yu'\h'-|\\n(^lu+3n'
.sp -1
.fi
.ev
.\}
.nr ^v 0
..
'\"	# Special macro to handle page bottom:  finish off current
'\"	# box/sidebar if in box/sidebar mode, then invoked standard
'\"	# page bottom macro.
.de ^B
.ev 2
'ti 0
'nf
.mk ^t
.if \\n(^b \{\
.\"	Draw three-sided box if this is the box's first page,
.\"	draw two sides but no top otherwise.
.ie !\\n(^b-1 \h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.el \h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.\}
.if \\n(^v \{\
.nr ^x \\n(^tu+1v-\\n(^Yu
\kx\h'-\\nxu'\h'|\\n(^lu+3n'\ky\L'-\\n(^xu'\v'\\n(^xu'\h'|0u'\c
.\}
.bp
'fi
.ev
.if \\n(^b \{\
.mk ^y
.nr ^b 2
.\}
.if \\n(^v \{\
.mk ^Y
.\}
..
'\"	# DS - begin display
.de DS
.RS
.nf
.sp
..
'\"	# DE - end display
.de DE
.fi
.RE
.sp .5
..
'
'
'----------------------------------------------------------------------
.HS tixDlgBtns tix 3.6
.BS
'
'
'----------------------------------------------------------------------
.SH NAME
tixDlgBtns - Create and manipulate TIX \fBDialog Buttons\fR widgets
'
'
'
'----------------------------------------------------------------------
.SH SYNOPSIS
\fBtixDlgBtns\fI \fIpathName ?\fIoptions\fR?
'
'
'
'----------------------------------------------------------------------
.SH "STANDARD OPTIONS"
.LP
.nf
.ta 4c 8c 12c
.VS
\fB
'
anchor	background	cursor
relief	borderWidth	geometry
'
\fR
.fi
.LP
See the ``options'' manual entry for details on the standard options.
'
'
'----------------------------------------------------------------------
.SH "WIDGET-SPECIFIC OPTIONS"
'
'----------BEGIN
.LP
.nf
Name:		\fBfont\fR
Class:		\fBFont\fR
Command-Line Switch:	\fB\-font\fR
.fi
.IP
Specifies the font used by all the buttons inside the DlgBtns widget.
'----------END
'
'----------BEGIN
.LP
.nf
Name:		\fBforeground\fR
Class:		\fBForeground\fR
Command-Line Switch:	\fB\-foreground\fR
.fi
.IP
Specifies the foreground of all the buttons inside the DlgBtns widget.
'----------END
'
'
'----------BEGIN
.LP
.nf
Name:		\fBbuttonBg\fR
Class:		\fBBackground\fR
Command-Line Switch:	\fB\-buttonbg\fR
.fi
.IP
Specifies the background of all the buttons inside the DlgBtns widget.
'----------END

'----------BEGIN
.LP
.nf
Name:		\fBorientation\fR
Class:		\fBOrientation\fR
Command-Line Switch:	\fB\-orientation\fR
Alias:		\fB\-orient\fR
.fi
.IP
\fBStatic Option\fR. Specifies the orientation of the button
subwidgets. Only the values "horizontal" and "vertical" are recognized.
'----------END

'----------BEGIN
.LP
.nf
Name:		\fBpadx\fR
Class:		\fBPad\fR
Command-Line Switch:	\fB\-padx\fR
.fi
.IP
Specifies the horizontal padding between two neighboring button
subwidgets in the DlgBtns widget.
'----------END

'----------BEGIN
.LP
.nf
Name:		\fBpadx\fR
Class:		\fBPad\fR
Command-Line Switch:	\fB\-padx\fR
.fi
.IP
Specifies the vertical padding between two neighboring button
subwidgets in the DlgBtns widget.
'----------END

'----------BEGIN
.LP
.nf
Name:		\fBstate\fR
Class:		\fBState\fR
Command-Line Switch:	\fB\-state\fR
.fi
.IP
Specifies the state of all the buttons inside the \fBSelect\fR widget.

\fINote\fR:
Setting this option using the \fIconfig\fR widget command will enable
or disable all the buttons subwidgets. Original states of the
individual buttons are \fInot\fR saved. Only the values "normal" and
"disabled" are recognized.
'----------END


.VE
.BE
'
'
'
'----------------------------------------------------------------------
.SH DESCRIPTION
'
.PP
'
The \fBtixDlgBtns\fR command creates a new window (given by the
\fIpathName\fR argument) and makes it into a DlgBtns widget. The
DlgBtns, or Dialog Buttons, widget is a container widget to hold
the ``action'' buttons in a dialog box.
Additional options, described above, may be specified on the command
line or in the option database to configure aspects of the DlgBtns such
as its cursor and relief.
'
'
'----------------------------------------------------------------------
.SH "WIDGET COMMAND"
.PP
'
The \fBDlgBtns\fR command creates a new Tcl command whose
name is the same as the path name of the DlgBtns's window.  This
command may be used to invoke various
operations on the widget.  It has the following general form:
'
.DS C
'
\fIpathName option \fR?\fIarg arg ...\fR?

.DE
'
\fIPathName\fR is the name of the command, which is the same as
the frame widget's path name.  \fIOption\fR and the \fIarg\fRs
determine the exact behavior of the command.  The following
commands are possible for DlgBtns widgets:
'
.TP
'
\fIpathName \fBconfigure\fR ?\fIoption\fR? \fI?value option value ...\fR?
Query or modify the configuration options of the widget.
If no \fIoption\fR is specified, returns a list describing all of
the available options for \fIpathName\fR (see \fBTk_ConfigureInfo\fR for
information on the format of this list).  If \fIoption\fR is specified
with no \fIvalue\fR, then the command returns a list describing the
one named option (this list will be identical to the corresponding
sublist of the value returned if no \fIoption\fR is specified).  If
one or more \fIoption\-value\fR pairs are specified, then the command
modifies the given widget option(s) to have the given value(s);  in
this case the command returns an empty string.
\fIOption\fR may have any of the values accepted by the \fBframe\fR
command.
'
.TP
\fIpathName add buttonName ?\fIoption value ... \fR?
Add a new button subwidget
with the name \fRbnuttonName\fR into the DlgBtns widget. Additional
configuration options can be given to configure the new button subwidget.
'
'
.TP
\fIpathName button bnuttonName ?\fIargs\fR?
The \fIbutton\fR command provides a way to access a button
subwidget contained by the DlgBtns widget.
'
When no additional arguments are given this command returns return the
complete pathname of the button subwidget with the name
\fRbnuttonName\fR.
'
When additional arguments are given, these arguments are used to
invoke the widget command of the button subwidget.
'
.TP
\fIpathName invoke bnuttonName
Invoke the button subwidget with the name \fRbnuttonName\fR.
'
'----------------------------------------------------------------------
.SH BINDINGS
.PP
DlgBtns widgets have no default bindings.
'
'
'----------------------------------------------------------------------
.SH EXAMPLE
.PP
'
The following example creates a DlgBtns widget which contains several
button subwidgets.
'
.PP
.nf
 tixDlgBtns .btns

 #Add some buttons in to the DlgBtns
 .btns add open  -text "Open"  -command "open_proc"
 .btns add close -text "CLose" -command "close_proc"

 #Further configure the "open" button
 .btns button open config -foreground red

 #Invoke the "open" button
 .btns invoke open
.fi
'
'
'
'----------------------------------------------------------------------
.SH AUTHOR
.PP
Ioi Kim Lam - ioi@graphics.cis.upenn.edu
'
'----------------------------------------------------------------------
.SH KEYWORDS
TIX, Container Widgets
