'\"
.\"
.\" .HS name section [date [version]]
.\"	Replacement for .TH in other man pages.  See below for valid
.\"	section names.
.\"
.\" .AP type name in/out [indent]
.\"	Start paragraph describing an argument to a library procedure.
.\"	type is type of argument (int, etc.), in/out is either "in", "out",
.\"	or "in/out" to describe whether procedure reads or modifies arg,
.\"	and indent is equivalent to second arg of .IP (shouldn't ever be
.\"	needed;  use .AS below instead)
.\"
.\" .AS [type [name]]
.\"	Give maximum sizes of arguments for setting tab stops.  Type and
.\"	name are examples of largest possible arguments that will be passed
.\"	to .AP later.  If args are omitted, default tab stops are used.
.\"
.\" .BS
.\"	Start box enclosure.  From here until next .BE, everything will be
.\"	enclosed in one large box.
.\"
.\" .BE
.\"	End of box enclosure.
.\"
.\" .VS
.\"	Begin vertical sidebar, for use in marking newly-changed parts
.\"	of man pages.
.\"
.\" .VE
.\"	End of vertical sidebar.
.\"
.\" .DS
.\"	Begin an indented unfilled display.
.\"
.\" .DE
.\"	End of indented unfilled display.
.\"
'\"	# Heading for TIX man pages
.de HS
.if '\\$2'tix'        .TH \\$1 n \\$3 \\TIX
.if t .wh -1.3i ^B
.nr ^l \\n(.l
.ad b
..
'\"	# Start an argument description
.de AP
.ie !"\\$4"" .TP \\$4
.el \{\
.   ie !"\\$2"" .TP \\n()Cu
.   el          .TP 15
.\}
.ie !"\\$3"" \{\
.ta \\n()Au \\n()Bu
\&\\$1	\\fI\\$2\\fP	(\\$3)
.\".b
.\}
.el \{\
.br
.ie !"\\$2"" \{\
\&\\$1	\\fI\\$2\\fP
.\}
.el \{\
\&\\fI\\$1\\fP
.\}
.\}
..
'\"	# define tabbing values for .AP
.de AS
.nr )A 10n
.if !"\\$1"" .nr )A \\w'\\$1'u+3n
.nr )B \\n()Au+15n
.\"
.if !"\\$2"" .nr )B \\w'\\$2'u+\\n()Au+3n
.nr )C \\n()Bu+\\w'(in/out)'u+2n
..
'\"	# BS - start boxed text
'\"	# ^y = starting y location
'\"	# ^b = 1
.de BS
.br
.mk ^y
.nr ^b 1u
.if n .nf
.if n .ti 0
.if n \l'\\n(.lu\(ul'
.if n .fi
..
'\"	# BE - end boxed text (draw box now)
.de BE
.nf
.ti 0
.mk ^t
.ie n \l'\\n(^lu\(ul'
.el \{\
.\"	Draw four-sided box normally, but don't draw top of
.\"	box if the box started on an earlier page.
.ie !\\n(^b-1 \{\
\h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.el \}\
\h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.\}
.fi
.br
.nr ^b 0
..
'\"	# VS - start vertical sidebar
'\"	# ^Y = starting y location
'\"	# ^v = 1 (for troff;  for nroff this doesn't matter)
.de VS
.mk ^Y
.ie n 'mc \s12\(br\s0
.el .nr ^v 1u
..
'\"	# VE - end of vertical sidebar
.de VE
.ie n 'mc
.el \{\
.ev 2
.nf
.ti 0
.mk ^t
\h'|\\n(^lu+3n'\L'|\\n(^Yu-1v\(bv'\v'\\n(^tu+1v-\\n(^Yu'\h'-|\\n(^lu+3n'
.sp -1
.fi
.ev
.\}
.nr ^v 0
..
'\"	# Special macro to handle page bottom:  finish off current
'\"	# box/sidebar if in box/sidebar mode, then invoked standard
'\"	# page bottom macro.
.de ^B
.ev 2
'ti 0
'nf
.mk ^t
.if \\n(^b \{\
.\"	Draw three-sided box if this is the box's first page,
.\"	draw two sides but no top otherwise.
.ie !\\n(^b-1 \h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.el \h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.\}
.if \\n(^v \{\
.nr ^x \\n(^tu+1v-\\n(^Yu
\kx\h'-\\nxu'\h'|\\n(^lu+3n'\ky\L'-\\n(^xu'\v'\\n(^xu'\h'|0u'\c
.\}
.bp
'fi
.ev
.if \\n(^b \{\
.mk ^y
.nr ^b 2
.\}
.if \\n(^v \{\
.mk ^Y
.\}
..
'\"	# DS - begin display
.de DS
.RS
.nf
.sp
..
'\"	# DE - end display
.de DE
.fi
.RE
.sp .5
..
'
'
.HS TIX tix 3.6
.BS
'
'
.SH NAME
TIX - Summary of the TIX widget set
'
'
'
.SH SYNOPSIS

\fBtixInit\fI ?-beta boolean? ?-binding bName? ?-debug boolean?
?-fontset fName? ?-libdir path? ?-scheme sName? 

.BE
.SH DESCRIPTION

TIX is a set of compound widgets based on TK 3.6. It is solely written
in TCL using the \fBTIX Intrinsics\fR library and does not require any
recompilation of TCL/TK. The latest release of Tix is Tix 3.6.

To use the \fBTIX\fR widgets, you have to append the library directory of
TIX to the auto-load path by using the following command: (assuming that you
have installed TIX in /usr/local/lib/tix)

.nf
lappend auto_path /usr/local/lib/tix
.fi


The TIX widget set must be initialized before you can use it. You can
initialize TIX using the command \fBtixInit\fR. It accetps the
following options:


\fB-beta\fI boolean\fR: Specifies whether you want to use the widgets
inside the directory library/beta. Only values "true" and "false" are
allowed. The widgets in this directory are consider unstable and you
are advised not to use them in any critical applications. These
widgets are \fBnot guaranteed\fR to be supported in the future. The
default value is "true".

\fB-binding\fI bName\fR: Specifies the event bindings. In this version
of Tix, the bindings supported are \fBMotif\fR, which will make your
application behave close to Motif(tm), and \fBTK\fR.
The default is \fBTK\fR.

\fB-debug\fI boolean\fR: Specifies whether the Intrinsics should be
debugged. Only values "true" and "false" are allowed. If this option
is enabled, all the internal errors will be printed. This option is
useful for Tix widget developers and hackers.

\fB-fontset\fI fName\fR: The fontset to use in your application. A
fontset defines the fonts to be used as normal text, bold font, italic
font ... etc. In this version of Tix, the fontsets supported are \fB12Point\fR,
\fB14Point\fR and \fBTK\fR. The default is \fBTK\fR.

\fB-libdir\fI path\fR: The path of the directory that contains the
Tix library. The default value is \fB/usr/local/lib/tix.

\fB-scheme\fI sName\fR: The color scheme to use in your application.
In this version of Tix, the schemes supported are \fBGray\fR,
\fBSGIGray\fR, \fBBlue\fR and \fBTK\fR. The default is
\fBTK\fR.

.SH Example TIX startup script

.nf
#!/usr/local/bin/wish -f
set TIX_LIBRARY  /usr/local/lib/tix

lappend auto_path $TIX_LIBRARY
tixInit -libdir $TIX_LIBRARY -scheme Gray -fontset 14Point -binding Motif

# At here, jump to the start of your program
.fi

.SH Files

There are files in the \fIdemos\fR directory in the TIX distribution
that illustrates how you can include TIX in your application.

.SH AUTHOR

Ioi Kim Lam - ioi@graphics.cis.upenn.edu


.SH KEYWORDS

TIX, compound widgets, TIX Intrinsics
